/*  libhrel - Holyrel library

    Copyright (C) 2005 Chong Kai Xiong <descender@phreaker.net>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the
    Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA  02111-1307  USA.
*/

#ifndef H_GTK_TREE_MODEL_H
#define H_GTK_TREE_MODEL_H

#include <glib-object.h>
#include <gtk/gtktreemodel.h>
#include <libhrel/relation.h>
#include <stdarg.h>

G_BEGIN_DECLS

#define H_TYPE_GTK_RELATION_STORE            (h_gtk_relation_store_get_type ())
#define H_GTK_RELATION_STORE(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), H_TYPE_GTK_RELATION_STORE, HGtkRelationStore))
#define H_GTK_RELATION_STORE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST    ((klass), H_TYPE_GTK_RELATION_STORE, HGtkRelationStoreClass))
#define H_IS_GTK_RELATION_STORE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), H_TYPE_GTK_RELATION_STORE))
#define H_IS_GTK_RELATION_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE    ((klass), H_TYPE_GTK_RELATION_STORE))
#define H_GTK_RELATION_STORE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS  ((obj), H_TYPE_GTK_RELATION_STORE, HGtkRelationStoreClass))

typedef struct _HGtkRelationStore      HGtkRelationStore;
typedef struct _HGtkRelationStoreClass HGtkRelationStoreClass;

struct _HGtkRelationStore
{
  GObject parent;
};

struct _HGtkRelationStoreClass
{
  GObjectClass parent_class;
};


GType              h_gtk_relation_store_get_type (void);
HGtkRelationStore *h_gtk_relation_store_new      (HRelation *relation,
                                                  ...);
HGtkRelationStore *h_gtk_relation_store_new_v    (HRelation *relation,
                                                  va_list    args);

G_END_DECLS

#endif
