#include <config.h>
#include <glib.h>
#include <libhrel/hash_table.h>

static gboolean
key_equal (gint         x,
           gint         y,
           const gchar *msg)
{
  g_message ("key_equal: data passed: %s", msg);

  return (x == y);
}

static guint
key_hash (gint         key,
          const gchar *msg)
{
  g_message ("key_hash: data passed: %s", msg);

  /* Make every key collide */
  return 0;
}

gint
main (void)
{
  HHashTable *table;
  gint i;

  table = h_hash_table_new ((HHashFunc) key_hash, "hello",
                            (HEqualFunc) key_equal, "world");

  for (i = 0; i < 5; i++)
  {
      h_hash_table_insert (table,
                           GINT_TO_POINTER (i),
                           GINT_TO_POINTER (i+1));
  }

  h_hash_table_destroy (table);

  return 0;
}
