#include <stdio.h>
#include <glib.h>
#include <libhrel/types.h>
#include <libhrel/relation.h>

gint
main (void)
{
    HRelation *relation1;
    HRelation *relation2;
    HRelation *result;

    h_type_init ();

    relation1 = h_relation_base_new ("A", "A",
                                     "x", G_TYPE_INT,
                                     "y", G_TYPE_INT,
                                     NULL,
                                     "x", "y",
                                     NULL);

    relation2 = h_relation_base_new ("B", "B",
                                     "x", G_TYPE_INT,
                                     "y", G_TYPE_INT,
                                     NULL,
                                     "x", "y",
                                     NULL);

    h_relation_base_insert_tuplev (H_RELATION_BASE (relation1), "x", 20, "y", 30);
    h_relation_base_insert_tuplev (H_RELATION_BASE (relation2), "x", 30, "y", 50);

    h_relation_base_insert_tuplev (H_RELATION_BASE (relation1), "x", 10, "y", 20);
    h_relation_base_insert_tuplev (H_RELATION_BASE (relation2), "x", 10, "y", 20);

    result = h_relation_union (relation1, relation2);

    h_relation_print (result);

    h_relation_base_delete_tuplev (H_RELATION_BASE (relation1), "x", 20, "y", 30);
    h_relation_base_delete_tuplev (H_RELATION_BASE (relation1), "x", 10, "y", 20);

    h_relation_print (result);

    h_relation_base_delete_tuplev (H_RELATION_BASE (relation2), "x", 10, "y", 20);
    h_relation_print (result);

    g_object_unref (result);

    return 0;
}
